using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing.Text;
using System.Diagnostics;
using System.IO;

using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmGrid.
	/// </summary>
	public class frmCellMerge : System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridRow rowTitle1;
		private ppsGrid.GridRow rowTitle2;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colMarke;
		private ppsGrid.GridCol colFabrikat;
		private ppsGrid.GridCol ColBaujahr;
		private ppsGrid.GridCol colPreis;
		private ppsGrid.GridCol colLeistung;
		private ppsGrid.GridCol colAbgase;
		private ppsGrid.GridRow gridRow1;
		private ppsGrid.GridRow gridRow2;
		private ppsGrid.GridRow gridRow3;
		private ppsGrid.GridRow gridRow4;
		private ppsGrid.GridCol colBild;

		public frmCellMerge() {
			InitializeComponent();
		}


		/// <summary>Init form</summary>
		public void Init(){
			Graphics	gfx=CreateGraphics();
			int				wdth,cnt=1;
			Bitmap		bm;
			GridRow		row;
			string[]	data;
			string		titel2="Marke,Modell,Preis,Abgas,Farbe,Baujahr,Bild";
			string		titel3="Name,Name,Preis,Abgas,Farbe,Datum,Bild";
			string[]	autos=new string[] {
				"BMW,1er,320,wenig,wenig,2002,bmw1er_1",
				"BMW,3er,455,mittel,schwarz,2000,bmw3er_1",
				"BMW,5er,582,viel,silber,2000,bmw5er_1",
				"VW,Polo,212,mittel,silber,2002,polo_1",
				"VW,Polo,218,mittel,mittel,2003,polo_2",
				"VW,Polo,212,mittel,schwarz,2001,polo_3",
				"7,Golf,304,viel,silber,2002,golf_1",
				"VW,Golf,288,gelb,gelb,2002,golf_2",
				"VW,Passat,438,viel,grn,2002,passat_1",
				"Mercedes,A140,225,viel,silber,2001,mb140_1",
				"Mercedes,A140,220,viel,silber,2002,mb140_2",
				"Mercedes,SLK,512,sehr viel,schwarz,2002,mbSlk_1",
				"Posche,Boxster,630,schwarz,schwarz,2001,boxster_1",
				"Posche,Boxster,612,schwarz,schwarz,2003,boxster_2",
				"Ford,Ka,218,mittel,blau,2002,ka_1",
				"Ford,Ka,240,mittel,rot,2003,ka_2",
				"Smart,ForTwo,185,wenig,schwarz,2003,smart_1",
				"Smart,ForTwo,197,wenig,grau,2003,smart_2",
			};

			grid.StringAlignHorz=grid.StringAlignVert=eContentAlign.Center;
			grid.CellPadding.All=4;

			foreach(GridCol c in grid.Cols){
				c.CellMerge=true;
				c.Name=null;
			}

			foreach(string s in titel2.Split(',')){
				grid[cnt,0].Value=s;
				grid.Cols[cnt++].Name="col"+s;
			}
			cnt=1;
			foreach(string s in titel3.Split(','))
				grid[cnt++,1].Value=s;

			foreach(string s in autos){
				grid.AddRows(1);
				row=grid.Rows[grid.Rows.Count-1];
				data=s.Split(',');
				cnt=1;
				foreach(string c in data){
					if(c.IndexOf("_")==-1)																						// bild (unterstrich)
						row[cnt++].Value=c;																							// ..nein
					else{
						string	p=Application.StartupPath;															// ..ja
						
						p+=@"\pics\cars\"+c+".jpg";
						bm=new Bitmap(p);
						row.Height=(int)(gfx.DpiY*bm.Height/bm.VerticalResolution);
						wdth=(int)(gfx.DpiX*bm.Width/bm.HorizontalResolution);
						if(grid.Cols["colBild"].Width<wdth)			
							grid.Cols["colBild"].Width=wdth;

						row[cnt].Image=bm;
						cnt++;
					}
				}
			}
			
			foreach(GridRow r in grid.Rows)
				r.CellMerge=true;
			gfx.Dispose();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.grid = new ppsGrid.Grid();
			this.colNo = new ppsGrid.GridCol();
			this.colMarke = new ppsGrid.GridCol();
			this.colFabrikat = new ppsGrid.GridCol();
			this.colBild = new ppsGrid.GridCol();
			this.ColBaujahr = new ppsGrid.GridCol();
			this.colLeistung = new ppsGrid.GridCol();
			this.colAbgase = new ppsGrid.GridCol();
			this.colPreis = new ppsGrid.GridCol();
			this.gridRow3 = new ppsGrid.GridRow();
			this.gridRow4 = new ppsGrid.GridRow();
			this.rowTitle1 = new ppsGrid.GridRow();
			this.rowTitle2 = new ppsGrid.GridRow();
			this.gridRow1 = new ppsGrid.GridRow();
			this.gridRow2 = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.BackColorCellGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.grid.BackColorFixedGradient = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(128)), ((System.Byte)(255)));
			this.grid.BackColorFocus = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(128)), ((System.Byte)(255)));
			this.grid.BackColorHighlight = System.Drawing.Color.Yellow;
			this.grid.CellHomeVisible = true;
			this.grid.Cols.AddRange(new object[] {
																						 this.colNo,
																						 this.colMarke,
																						 this.colFabrikat,
																						 this.colBild,
																						 this.ColBaujahr,
																						 this.colLeistung,
																						 this.colAbgase,
																						 this.colPreis});
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.Location = new System.Drawing.Point(8, 8);
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.gridRow3,
																						 this.gridRow4});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.ScrollbarVisible = ppsGrid.eScrollbarVisible.Required;
			this.grid.SelectionType = ppsGrid.eSelectionType.None;
			this.grid.Size = new System.Drawing.Size(459, 195);
			this.grid.TabIndex = 0;
			// 
			// colNo
			// 
			this.colNo.AutoNumber = true;
			this.colNo.Fixed = true;
			this.colNo.Name = "colNo";
			// 
			// colMarke
			// 
			this.colMarke.Name = "colMarke";
			// 
			// colFabrikat
			// 
			this.colFabrikat.Name = "colFabrikat";
			// 
			// colBild
			// 
			this.colBild.Name = "colBild";
			// 
			// ColBaujahr
			// 
			this.ColBaujahr.Name = "ColBaujahr";
			// 
			// colLeistung
			// 
			this.colLeistung.Name = "colLeistung";
			// 
			// colAbgase
			// 
			this.colAbgase.Name = "colAbgase";
			// 
			// colPreis
			// 
			this.colPreis.Name = "colPreis";
			// 
			// gridRow3
			// 
			this.gridRow3.CellMerge = true;
			this.gridRow3.Fixed = true;
			this.gridRow3.Height = 20;
			this.gridRow3.Name = "gridRow3";
			// 
			// gridRow4
			// 
			this.gridRow4.CellMerge = true;
			this.gridRow4.Fixed = true;
			this.gridRow4.Height = 20;
			this.gridRow4.Name = "gridRow4";
			// 
			// rowTitle1
			// 
			this.rowTitle1.CellMerge = true;
			this.rowTitle1.Fixed = true;
			this.rowTitle1.Name = "rowTitle1";
			// 
			// rowTitle2
			// 
			this.rowTitle2.CellMerge = true;
			this.rowTitle2.Fixed = true;
			this.rowTitle2.Name = "rowTitle2";
			// 
			// gridRow1
			// 
			this.gridRow1.Fixed = true;
			this.gridRow1.Name = "gridRow1";
			// 
			// gridRow2
			// 
			this.gridRow2.Fixed = true;
			this.gridRow2.Name = "gridRow2";
			// 
			// frmCellMerge
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(475, 211);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid});
			this.DockPadding.All = 8;
			this.Name = "frmCellMerge";
			this.Text = "Cell-Merge";
			this.ResumeLayout(false);

		}
		#endregion

	}
}