using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmCtrlCheckbox.
	/// </summary>
	public class frmCtrlCalendar : System.Windows.Forms.Form	{
		private System.Windows.Forms.Label label1;
		private ppsGrid.GridRow rowDispFixed;
		private ppsGrid.GridCol colStd;
		private ppsGrid.GridCol colMo;
		private ppsGrid.GridCol colDi;
		private ppsGrid.GridCol colMi;
		private ppsGrid.GridCol colDo;
		private ppsGrid.GridCol colFr;
		private ppsGrid.GridCol colSa;
		private ppsGrid.GridCol colSo;
		private ppsGrid.Grid grid;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlCalendar(){
			InitializeComponent();
		}
		/// <summary>Rechnungsposittionen initialisieren</summary>
		public void Init(){
			int	rw=0;

			grid.Cols["colStd"].StringAlignVert=eContentAlign.Center;
			for(int cl=0;cl<7;cl++){
				grid[cl+1,0].FormatString="dddd";
				grid[cl+1,0].StringAlignHorz=eContentAlign.Center;
				grid[cl+1,0].Font=new Font("Tahoma",9,FontStyle.Bold);
				grid[cl+1,0].Value=new DateTime(2005,7,25+cl);
			}
			grid.PreferredRowHeight=16;
			grid.AddRows(195);											// 1 Zeile pro Minute

			TimeSpan	mn=new TimeSpan(0,5,0);
			DateTime	dt=DateTime.Today;
			for(TimeSpan ts=new TimeSpan(5,53,0);ts.TotalMinutes<1327;ts=ts.Add(mn)){
				rw++;
				grid["colStd",rw].Value=dt+new TimeSpan((int)ts.TotalHours,(int)(Math.Round((double)ts.Minutes/30)*30),0);
				grid["colMo",rw].Value=rw;
			}
		}

		
		
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if( disposing ){
				if(components != null){
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid = new ppsGrid.Grid();
			this.colStd = new ppsGrid.GridCol();
			this.colMo = new ppsGrid.GridCol();
			this.colDi = new ppsGrid.GridCol();
			this.colMi = new ppsGrid.GridCol();
			this.colDo = new ppsGrid.GridCol();
			this.colFr = new ppsGrid.GridCol();
			this.colSa = new ppsGrid.GridCol();
			this.colSo = new ppsGrid.GridCol();
			this.rowDispFixed = new ppsGrid.GridRow();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grid.BackColorHighlight = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.grid.CellFrameType = ppsGrid.eCellFrameType.None;
			this.grid.CellPadding.All = 0;
			this.grid.Cols.AddRange(new object[] {
																						 this.colStd,
																						 this.colMo,
																						 this.colDi,
																						 this.colMi,
																						 this.colDo,
																						 this.colFr,
																						 this.colSa,
																						 this.colSo});
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.grid.Location = new System.Drawing.Point(16, 24);
			this.grid.Name = "grid";
			this.grid.PreferredRowHeight = 24;
			this.grid.Rows.AddRange(new object[] {
																						 this.rowDispFixed});
			this.grid.SelectionDashStyle = ppsGrid.eDashStyle.Solid;
			this.grid.SelectionFrameWidth = 4;
			this.grid.SelectionMode = ppsGrid.eSelectionMode.Multiple;
			this.grid.SelectionType = ppsGrid.eSelectionType.Free;
			this.grid.Size = new System.Drawing.Size(696, 426);
			this.grid.TabIndex = 0;
			this.grid.CellMouseLeave += new ppsGrid.OnCellMouseLeave(this.grid_CellMouseLeave);
			this.grid.CellMouseEnter += new ppsGrid.OnCellMouseEnter(this.grid_CellMouseEnter);
			// 
			// colStd
			// 
			this.colStd.CellMerge = true;
			this.colStd.FormatString = "t";
			this.colStd.Name = "colStd";
			this.colStd.Width = 40;
			// 
			// colMo
			// 
			this.colMo.FormatString = "0.00";
			this.colMo.Name = "colMo";
			this.colMo.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colMo.WidthPercent = 14;
			this.colMo.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colDi
			// 
			this.colDi.Name = "colDi";
			this.colDi.WidthPercent = 14;
			this.colDi.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colMi
			// 
			this.colMi.Name = "colMi";
			this.colMi.WidthPercent = 14;
			this.colMi.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colDo
			// 
			this.colDo.Name = "colDo";
			this.colDo.WidthPercent = 14;
			this.colDo.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colFr
			// 
			this.colFr.FormatString = "0.00 kg";
			this.colFr.Name = "colFr";
			this.colFr.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colFr.WidthPercent = 14;
			this.colFr.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colSa
			// 
			this.colSa.FormatString = "C";
			this.colSa.Name = "colSa";
			this.colSa.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colSa.WidthPercent = 14;
			this.colSa.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colSo
			// 
			this.colSo.FormatString = "C";
			this.colSo.Name = "colSo";
			this.colSo.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colSo.WidthPercent = 14;
			this.colSo.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowDispFixed
			// 
			this.rowDispFixed.Fixed = true;
			this.rowDispFixed.Name = "rowDispFixed";
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(688, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Kalender";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// frmCtrlCalendar
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(720, 453);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.label1,
																																	this.grid});
			this.Name = "frmCtrlCalendar";
			this.Text = "Kalender";
			this.ResumeLayout(false);

		}
		#endregion

		private void grid_CellMouseEnter(object sender, ppsGrid.CellMouseEventArgs e) {
//			Console.WriteLine(DateTime.Now+", Enter Cell:"+e.Column+","+e.Row);
		}

		private void grid_CellMouseLeave(object sender, ppsGrid.CellMouseEventArgs e) {
//			Console.WriteLine(DateTime.Now+", Leave Cell:"+e.Column+","+e.Row);
		}
	}
}
