using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing.Text;
using System.Text;
using System.Diagnostics;
using System.IO;
using System.Reflection;

using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmGrid.
	/// </summary>
	public class frmCtrlControl : System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridCol colFixed;
		private ppsGrid.GridCol colCheckBox;
		private ppsGrid.GridCol colTextBox;
		private ppsGrid.GridCol colComboBox;
		private ppsGrid.GridRow rowTitle;
		private ppsGrid.GridCol colTrackBar;
		private ppsGrid.GridCol colButton;
		private ppsGrid.GridCol colListBox;
		private ppsGrid.GridCol colDateTime;
		private ppsGrid.GridCol colNumeric;
		private ppsGrid.GridCol colGrid;
		private ppsGrid.GridCol colRichTextBox;
		private ppsGrid.GridCol colProgressBar;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlControl() {
			InitializeComponent();
		}


		public static string RandomString(Random rnd,int max){
			int			cnt=rnd.Next(max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++)
				bff[i]=(byte)rnd.Next(97,97+26);
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}




		/// <summary>Init form</summary>
		public void Init(){
			Random					rnd=new Random();
			ListBox					lBox;
			ComboBox				cBox;
			TextBox					tBox;
			TrackBar				tBar;
			ProgressBar			pBar;
			GridInGrid			pGrd;
			Button					btn;
			CheckBox				chkBox;
			CheckBox				cllChkBox;
			RichTextBox			rtf;
			NumericUpDown		num;
			DateTimePicker	dte;

			grid.Anchor|=AnchorStyles.Right|AnchorStyles.Bottom;

			grid["colRichTextBox",0].Value="RichTextBox";
			grid["colComboBox",0].Value="ComboBox";
			grid["colCheckBox",0].Value="CheckBox";
			grid["colProgressBar",0].Value="ProgressBar";
			grid["colTrackBar",0].Value="TrackBar";
			grid["colButton",0].Value="Button";
			grid["colDateTime",0].Value="DateTimePicker";
			grid["colNumeric",0].Value="Numeric";
			grid["colGrid",0].Value="Grid";


			grid.BackColorCell=Color.LightSalmon;
			grid.PreferredRowHeight=100;
			grid.AddRows(40);



			// Spalte Trackbar
			tBar=new TrackBar();
			tBar.Maximum=100;
			grid.Cols["colTrackBar"].ControlDisplayInfo.Control=tBar;
			grid.Cols["colTrackBar"].ControlDisplayInfo.PropertyName="Value";

			tBar=new TrackBar();
			tBar.Maximum=100;
			tBar.ValueChanged += new System.EventHandler(this.Trackbar_Changed);
			grid.Cols["colTrackBar"].ControlEditInfo.Control=tBar;
			grid.Cols["colTrackBar"].ControlEditInfo.PropertyName="Value";




			// Spalte ProgressBar
			pBar=new ProgressBar();
			pBar.Minimum=0;
			pBar.Maximum=101;
			pBar.Dock=DockStyle.Top;
			grid.Cols["colProgressBar"].ControlDisplayInfo.Control=pBar;
			grid.Cols["colProgressBar"].ControlDisplayInfo.PropertyName="Value";




			// Spalte RichTextBox
			rtf=new RichTextBox();
			rtf.LoadFile(Application.StartupPath+"\\RTFdemo.rtf");
			rtf.Dock=DockStyle.Fill;
			rtf.BorderStyle=BorderStyle.None;
			grid.Cols["colRichTextBox"].ControlDisplayInfo.Control=rtf;
			grid.Cols["colRichTextBox"].ControlDisplayInfo.PropertyName="Rtf";

			rtf=new RichTextBox();
			rtf.Dock=DockStyle.Fill;
			rtf.BorderStyle=BorderStyle.None;
			grid.Cols["colRichTextBox"].ControlEditInfo.Control=rtf;
			grid.Cols["colRichTextBox"].ControlEditInfo.PropertyName="Rtf";


 
			// Spalte Button
			btn=new Button();
			btn.ImageAlign=ContentAlignment.MiddleLeft;
			btn.TextAlign=ContentAlignment.MiddleRight;
			btn.Image=Bitmap.FromFile(Application.StartupPath+@"\ppsGrid.bmp");
			btn.BackColor=SystemColors.Control;
			btn.Dock=DockStyle.None;
			btn.Text="...";
			btn.Width=48;
			btn.Height=40;
			grid.Cols["colButton"].CellPadding.All=3;
			grid.Cols["colButton"].ControlDisplayInfo.Control=btn;
			
			btn=new Button();
			btn.TextAlign=ContentAlignment.MiddleRight;
			btn.BackColor=SystemColors.Control;
			btn.Dock=DockStyle.None;
			btn.Text="Click me";
			btn.Width=48;
			btn.Height=40;
			btn.Click+=new EventHandler(this.Button_Click);
			grid.Cols["colButton"].CellPadding.All=3;
			grid.Cols["colButton"].ControlEditInfo.Control=btn;




			// Spalte Checkbox
			chkBox=new CheckBox();
			chkBox.TextAlign=ContentAlignment.MiddleRight;
			chkBox.Text="Checkbox";
			chkBox.SetBounds(2,2,96,96);
			chkBox.Dock=DockStyle.None;
			grid.Cols["colCheckBox"].CellPadding.All=4;
			grid.Cols["colCheckBox"].ControlDisplayInfo.Control=chkBox;
			grid.Cols["colCheckBox"].ControlDisplayInfo.PropertyName="Checked";

			chkBox=new CheckBox();
			chkBox.TextAlign=ContentAlignment.MiddleRight;
			chkBox.Text="Checkbox";
			chkBox.SetBounds(2,2,96,96);
			chkBox.Dock=DockStyle.None;
			grid.Cols["colCheckBox"].CellPadding.All=4;
			grid.Cols["colCheckBox"].ControlEditInfo.Control=chkBox;
			grid.Cols["colCheckBox"].ControlEditInfo.PropertyName="Checked";

			cllChkBox=new CheckBox();
			cllChkBox.Text="Cellbox (ReadOnly)";
			cllChkBox.TextAlign=ContentAlignment.MiddleLeft;
			grid["colCheckBox",12].ControlDisplayInfo.Control=cllChkBox;
			grid["colCheckBox",12].ControlDisplayInfo.PropertyName="Checked";



			// Spalte TextBox
			tBox=new TextBox();
			tBox.Multiline=true;
			tBox.AcceptsReturn=tBox.AcceptsTab=true;
			tBox.TextAlign=HorizontalAlignment.Right;
			tBox.Dock=DockStyle.Right;
			tBox.Size=new Size(72,48);
			grid["colTextBox",0].Value="TextBox\nmit Multiline";
			grid.Cols["colTextBox"].CellPadding.All=0;
			grid.Cols["colTextBox"].ControlDisplayInfo.Control=tBox;
			grid.Cols["colTextBox"].ControlDisplayInfo.PropertyName="Text";

			tBox=new TextBox();
			tBox.Multiline=true;
			tBox.AcceptsReturn=tBox.AcceptsTab=true;
			tBox.TextAlign=HorizontalAlignment.Right;
			tBox.Dock=DockStyle.Right;
			tBox.Size=new Size(72,48);
			grid.Cols["colTextBox"].ControlEditInfo.Control=tBox;
			grid.Cols["colTextBox"].ControlEditInfo.PropertyName="Text";




			// Spalte Listbox
			string[]	tr=new String[]{"[ReadOnly]","Hund","Katze","Maus","Frosch","Vogel","Elefant","Tiger","Fisch"};
			lBox=new ListBox();
			lBox.Items.AddRange(tr);
			lBox.Dock=DockStyle.Fill;
			grid.Cols["colListBox"].CellPadding.Left=4;
			grid.Cols["colListBox"].CellPadding.Top=4;
			grid.Cols["colListBox"].CellPadding.Right=0;
			grid.Cols["colListBox"].CellPadding.Bottom=0;
			lBox.IntegralHeight=false;
			grid["colListBox",0].Value="ListBox";
			grid.Cols["colListBox"].ControlDisplayInfo.PropertyName="SelectedItem";
			grid.Cols["colListBox"].ControlDisplayInfo.Control=lBox;


			// Spalte ComboBox
			string[]	nm=new String[]{"Gabi","Andreas","Claus","Manfred","Martina","Bettina","Angela","Torsten"};
			cBox=new ComboBox();
			cBox.Items.AddRange(nm);
			cBox.DropDownStyle=ComboBoxStyle.DropDownList;
			cBox.Dock=DockStyle.Top;
			grid.Cols["colComboBox"].BackColorCell=Color.LightBlue;
			grid.Cols["colComboBox"].ControlDisplayInfo.Control=cBox;
			grid.Cols["colComboBox"].ControlDisplayInfo.PropertyName="SelectedItem";

			cBox=new ComboBox();
			cBox.Items.AddRange(nm);
			cBox.DropDownStyle=ComboBoxStyle.DropDownList;
			cBox.Dock=DockStyle.Top;
			grid.Cols["colComboBox"].ControlEditInfo.Control=cBox;
			grid.Cols["colComboBox"].ControlEditInfo.PropertyName="SelectedItem";



			// Spalte Numeric
			num=new NumericUpDown();
			num.Dock=DockStyle.Bottom;
			num.Maximum=100;
			grid.Cols["colNumeric"].ControlDisplayInfo.Control=num;
			grid.Cols["colNumeric"].ControlDisplayInfo.PropertyName="Value";

			num=new NumericUpDown();
			num.Dock=DockStyle.Bottom;
			num.Maximum=100;
			grid.Cols["colNumeric"].ControlEditInfo.Control=num;
			grid.Cols["colNumeric"].ControlEditInfo.PropertyName="Value";



			// Spalte Trackbar
			tBar=new TrackBar();
			tBar.Maximum=100;
			grid.Cols["colTrackBar"].ControlDisplayInfo.Control=tBar;
			grid.Cols["colTrackBar"].ControlDisplayInfo.PropertyName="Value";

			tBar=new TrackBar();
			tBar.Maximum=100;
			tBar.ValueChanged += new System.EventHandler(this.Trackbar_Changed);
			grid.Cols["colTrackBar"].ControlEditInfo.Control=tBar;
			grid.Cols["colTrackBar"].ControlEditInfo.PropertyName="Value";

			
			
			// Spalte DateTimePicker
			dte=new DateTimePicker();
			dte.Format=DateTimePickerFormat.Short;
			dte.Dock=DockStyle.Top;
			grid.Cols["colDateTime"].ControlDisplayInfo.Control=dte;
			grid.Cols["colDateTime"].ControlDisplayInfo.PropertyName="Value";

			dte=new DateTimePicker();
			dte.Format=DateTimePickerFormat.Short;
			dte.Dock=DockStyle.Top;
			grid.Cols["colDateTime"].ControlEditInfo.Control=dte;
			grid.Cols["colDateTime"].ControlEditInfo.PropertyName="Value";




			// Spalte ppsGrid
			pGrd=new GridInGrid();
			pGrd.Dock=DockStyle.Fill;
			pGrd.Scrollbar=eScrollbar.None;
			grid.Cols["colGrid"].ControlDisplayInfo.Control=pGrd;
			grid.Cols["colGrid"].ControlDisplayInfo.PropertyName="myValue";

			pGrd=new GridInGrid();
			pGrd.Dock=DockStyle.Fill;
			pGrd.Scrollbar=eScrollbar.Both;
			grid.Cols["colGrid"].ControlEditInfo.Control=pGrd;
			grid.Cols["colGrid"].ControlEditInfo.PropertyName="myValue";



			for(int r=grid.FixedRowCount;r<grid.Rows.Count;r++){
				grid["colTextBox",r].Value=RandomString(rnd,20);
				grid["colTrackBar",r].Value=rnd.Next(100);
				grid["colProgressBar",r].Value=rnd.Next(100);
				grid["colCheckBox",r].Value=(rnd.Next(2)==0)?false:true;
				grid["colButton",r].Value=RandomString(rnd,12);
				grid["colComboBox",r].Value=nm[rnd.Next(cBox.Items.Count)];
		
				int rr=rnd.Next(lBox.Items.Count);
				grid["colListBox",r].Value=tr[rnd.Next(lBox.Items.Count)];
				grid["colDateTime",r].Value=DateTime.Today+TimeSpan.FromDays(rnd.Next(366));
				grid["colNumeric",r].Value=(Decimal)rnd.Next(100);
				grid["colDateTime",r].Value=DateTime.Now+new TimeSpan(rnd.Next(100),0,0,0);
				grid["colGrid",r].Value=new GridInGrid();
				grid["colRichTextBox",r].Value=((RichTextBox)grid.Cols["colRichTextBox"].ControlDisplayInfo.Control).Rtf;
			}
		}





		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmCtrlControl));
			this.grid = new ppsGrid.Grid();
			this.colFixed = new ppsGrid.GridCol();
			this.colRichTextBox = new ppsGrid.GridCol();
			this.colComboBox = new ppsGrid.GridCol();
			this.colTrackBar = new ppsGrid.GridCol();
			this.colProgressBar = new ppsGrid.GridCol();
			this.colListBox = new ppsGrid.GridCol();
			this.colTextBox = new ppsGrid.GridCol();
			this.colCheckBox = new ppsGrid.GridCol();
			this.colButton = new ppsGrid.GridCol();
			this.colDateTime = new ppsGrid.GridCol();
			this.colNumeric = new ppsGrid.GridCol();
			this.colGrid = new ppsGrid.GridCol();
			this.button1 = new System.Windows.Forms.Button();
			this.rowTitle = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.BackColorFixedGradient = System.Drawing.Color.Gray;
			this.grid.BackColorFocus = System.Drawing.Color.Pink;
			this.grid.BackColorHighlight = System.Drawing.Color.Pink;
			this.grid.Cols.AddRange(new object[] {
																						 this.colFixed,
																						 this.colRichTextBox,
																						 this.colComboBox,
																						 this.colTrackBar,
																						 this.colProgressBar,
																						 this.colListBox,
																						 this.colTextBox,
																						 this.colCheckBox,
																						 this.colButton,
																						 this.colDateTime,
																						 this.colNumeric,
																						 this.colGrid});
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.ForeColorFixed = System.Drawing.SystemColors.Info;
			this.grid.Location = new System.Drawing.Point(8, 8);
			this.grid.Name = "grid";
			this.grid.PreferredRowHeight = 48;
			this.grid.Rows.AddRange(new object[] {
																						 this.rowTitle});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.ScrollSmooth = -1;
			this.grid.SelectionType = ppsGrid.eSelectionType.Free;
			this.grid.Size = new System.Drawing.Size(440, 344);
			this.grid.TabIndex = 0;
			this.grid.CellAfterEdit += new ppsGrid.OnCellAfterEdit(this.grid_CellAfterEdit);
			// 
			// colFixed
			// 
			this.colFixed.AutoNumber = true;
			this.colFixed.Fixed = true;
			this.colFixed.Name = "colFixed";
			this.colFixed.Width = 40;
			// 
			// colRichTextBox
			// 
			this.colRichTextBox.CellPadding.All = 0;
			this.colRichTextBox.Name = "colRichTextBox";
			this.colRichTextBox.Width = 128;
			// 
			// colComboBox
			// 
			this.colComboBox.Name = "colComboBox";
			this.colComboBox.Width = 96;
			this.colComboBox.WidthPercent = 33;
			// 
			// colTrackBar
			// 
			this.colTrackBar.Name = "colTrackBar";
			this.colTrackBar.Width = 96;
			// 
			// colProgressBar
			// 
			this.colProgressBar.Name = "colProgressBar";
			this.colProgressBar.Width = 96;
			// 
			// colListBox
			// 
			this.colListBox.CellFrameDashStyle = ppsGrid.eDashStyle.Solid;
			this.colListBox.CellPadding.All = 0;
			this.colListBox.Name = "colListBox";
			this.colListBox.Width = 128;
			// 
			// colTextBox
			// 
			this.colTextBox.Name = "colTextBox";
			this.colTextBox.Width = 96;
			this.colTextBox.WidthPercent = 33;
			// 
			// colCheckBox
			// 
			this.colCheckBox.Name = "colCheckBox";
			this.colCheckBox.WidthPercent = 33;
			// 
			// colButton
			// 
			this.colButton.Name = "colButton";
			this.colButton.Width = 48;
			// 
			// colDateTime
			// 
			this.colDateTime.Name = "colDateTime";
			this.colDateTime.Width = 64;
			// 
			// colNumeric
			// 
			this.colNumeric.Name = "colNumeric";
			this.colNumeric.Width = 48;
			// 
			// colGrid
			// 
			this.colGrid.Name = "colGrid";
			this.colGrid.Width = 160;
			// 
			// button1
			// 
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(48, 16);
			this.button1.TabIndex = 1;
			this.button1.Text = "ttxt";
			this.button1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Height = 40;
			this.rowTitle.Name = "rowTitle";
			this.rowTitle.StringAlignHorz = ppsGrid.eContentAlign.Center;
			this.rowTitle.StringAlignVert = ppsGrid.eContentAlign.Center;
			// 
			// frmCtrlControl
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 373);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid,
																																	this.button1});
			this.DockPadding.All = 8;
			this.Name = "frmCtrlControl";
			this.Text = "frmGrid";
			this.ResumeLayout(false);

		}
		#endregion


		private void grid_CellAfterEdit(object sender, ppsGrid.CellAfterEditEventArgs e) {
			if(grid.Cols[e.Column].Name=="colTrackBar")
				grid["colProgressBar",e.Row].Value=grid["colTrackBar",e.Row].Value;
		}
		private void Trackbar_Changed(object sender, EventArgs e) {
			int	rw=grid.FocusCell.Y;
			grid["colProgressBar",rw].Value=((TrackBar)sender).Value;
		}
		private void Button_Click(object sender, EventArgs e) {
			MessageBox.Show("Klick in Spalte "+grid.FocusCell.X+", Zeile "+grid.FocusCell.Y);
		}
	}
}