using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmCtrlCheckbox.
	/// </summary>
	public class frmCtrlDatebox : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private ppsGrid.GridRow rowDispFixed;
		private ppsGrid.GridRow rowEditFixed;
		private ppsGrid.GridRow rowDispEditFixed;
		private ppsGrid.GridCol colDispEditNo;
		private ppsGrid.GridCol colEditNo;
		private ppsGrid.GridCol colDispNo;
		private ppsGrid.Grid grdDisp;
		private ppsGrid.Grid grdEdit;
		private ppsGrid.Grid grdDispEdit;
		private ppsGrid.GridCol colDispDate;
		private ppsGrid.GridCol colEditDate;
		private ppsGrid.GridCol colDispEditDate;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlDatebox(){
			InitializeComponent();
		}
		public void Init(){
			DateTimePicker	dte;
			Random					rnd=new Random();
			DateTime				frst=new DateTime(DateTime.Now.Year,1,1);

			dte=new DateTimePicker();
			dte.Dock=DockStyle.Top;
			dte.Format=DateTimePickerFormat.Short;

			grdDisp.PreferredRowHeight=24;
			grdDisp.AddRows(20);
			grdDisp.Cols["colDispDate"].ControlDisplayInfo.Control=dte;
			grdDisp.Cols["colDispDate"].ControlDisplayInfo.PropertyName="Value";
			foreach(GridRow r in grdDisp.Rows)
				if(r.Fixed==false)
					r["colDispDate"].Value=frst.AddDays(rnd.Next(365));

		



			dte=new DateTimePicker();
			dte.Dock=DockStyle.Top;
			dte.Format=DateTimePickerFormat.Custom;
			dte.CustomFormat="dd.MMMM.yyyy";
			grdEdit.PreferredRowHeight=24;
			grdEdit.AddRows(20);
			grdEdit.Cols["colEditDate"].FormatString="dd.MMMM.yyyy";
			grdEdit.Cols["colEditDate"].ControlEditInfo.Control=dte;
			grdEdit.Cols["colEditDate"].ControlEditInfo.PropertyName="Value";
			foreach(GridRow r in grdEdit.Rows)
				if(r.Fixed==false)
					r["colEditDate"].Value=frst.AddDays(rnd.Next(365));

		



		
			dte=new DateTimePicker();
			dte.Dock=DockStyle.Top;
			dte.Format=DateTimePickerFormat.Long;
			grdDispEdit.PreferredRowHeight=24;
			grdDispEdit.AddRows(20);
			grdDispEdit.Cols["colDispEditDate"].ControlDisplayInfo.Control=dte;
			grdDispEdit.Cols["colDispEditDate"].ControlDisplayInfo.PropertyName="Value";


			dte=new DateTimePicker();
			dte.Dock=DockStyle.Top;
			dte.Format=DateTimePickerFormat.Long;
			grdDispEdit.Cols["colDispEditDate"].ControlEditInfo.Control=dte;
			grdDispEdit.Cols["colDispEditDate"].ControlEditInfo.PropertyName="Value";
			foreach(GridRow r in grdDispEdit.Rows)
				if(r.Fixed==false)
					r["colDispEditDate"].Value=frst.AddDays(rnd.Next(365));
		}

		
		
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmCtrlDatebox));
			this.grdDisp = new ppsGrid.Grid();
			this.colDispNo = new ppsGrid.GridCol();
			this.colDispDate = new ppsGrid.GridCol();
			this.rowDispFixed = new ppsGrid.GridRow();
			this.grdEdit = new ppsGrid.Grid();
			this.colEditNo = new ppsGrid.GridCol();
			this.colEditDate = new ppsGrid.GridCol();
			this.rowEditFixed = new ppsGrid.GridRow();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.grdDispEdit = new ppsGrid.Grid();
			this.colDispEditNo = new ppsGrid.GridCol();
			this.colDispEditDate = new ppsGrid.GridCol();
			this.rowDispEditFixed = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grdDisp
			// 
			this.grdDisp.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.grdDisp.Cols.AddRange(new object[] {
																								this.colDispNo,
																								this.colDispDate});
			this.grdDisp.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDisp.Location = new System.Drawing.Point(8, 24);
			this.grdDisp.Name = "grdDisp";
			this.grdDisp.PreferredRowHeight = 24;
			this.grdDisp.Rows.AddRange(new object[] {
																								this.rowDispFixed});
			this.grdDisp.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDisp.Size = new System.Drawing.Size(152, 280);
			this.grdDisp.TabIndex = 0;
			// 
			// colDispNo
			// 
			this.colDispNo.AutoNumber = true;
			this.colDispNo.Fixed = true;
			this.colDispNo.Name = "colDispNo";
			this.colDispNo.Width = 25;
			this.colDispNo.WidthPercent = 35;
			// 
			// colDispDate
			// 
			this.colDispDate.Name = "colDispDate";
			this.colDispDate.WidthPercent = 100;
			this.colDispDate.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowDispFixed
			// 
			this.rowDispFixed.Fixed = true;
			this.rowDispFixed.Name = "rowDispFixed";
			// 
			// grdEdit
			// 
			this.grdEdit.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.grdEdit.Cols.AddRange(new object[] {
																								this.colEditNo,
																								this.colEditDate});
			this.grdEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdEdit.Location = new System.Drawing.Point(168, 24);
			this.grdEdit.Name = "grdEdit";
			this.grdEdit.Rows.AddRange(new object[] {
																								this.rowEditFixed});
			this.grdEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdEdit.Size = new System.Drawing.Size(152, 280);
			this.grdEdit.TabIndex = 0;
			// 
			// colEditNo
			// 
			this.colEditNo.AutoNumber = true;
			this.colEditNo.Fixed = true;
			this.colEditNo.Name = "colEditNo";
			this.colEditNo.Width = 25;
			this.colEditNo.WidthPercent = 35;
			// 
			// colEditDate
			// 
			this.colEditDate.Name = "colEditDate";
			this.colEditDate.WidthPercent = 100;
			this.colEditDate.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowEditFixed
			// 
			this.rowEditFixed.Fixed = true;
			this.rowEditFixed.Name = "rowEditFixed";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(144, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "nur Anzeige";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(176, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(136, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "nur Editieren";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(296, 0);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(192, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Anzeige+Editieren";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// grdDispEdit
			// 
			this.grdDispEdit.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grdDispEdit.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.grdDispEdit.CellPadding.All = 0;
			this.grdDispEdit.Cols.AddRange(new object[] {
																										this.colDispEditNo,
																										this.colDispEditDate});
			this.grdDispEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDispEdit.Location = new System.Drawing.Point(328, 24);
			this.grdDispEdit.Name = "grdDispEdit";
			this.grdDispEdit.PreferredRowHeight = 24;
			this.grdDispEdit.Rows.AddRange(new object[] {
																										this.rowDispEditFixed});
			this.grdDispEdit.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grdDispEdit.ScrollSmooth = -1;
			this.grdDispEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDispEdit.Size = new System.Drawing.Size(192, 280);
			this.grdDispEdit.TabIndex = 3;
			// 
			// colDispEditNo
			// 
			this.colDispEditNo.AutoNumber = true;
			this.colDispEditNo.Fixed = true;
			this.colDispEditNo.Name = "colDispEditNo";
			this.colDispEditNo.Width = 8;
			this.colDispEditNo.WidthPercent = 35;
			// 
			// colDispEditDate
			// 
			this.colDispEditDate.Name = "colDispEditDate";
			this.colDispEditDate.Width = 24;
			this.colDispEditDate.WidthPercent = 100;
			// 
			// rowDispEditFixed
			// 
			this.rowDispEditFixed.Fixed = true;
			this.rowDispEditFixed.Height = 24;
			this.rowDispEditFixed.Name = "rowDispEditFixed";
			// 
			// frmCtrlDatebox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 309);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.label3,
																																	this.grdDispEdit,
																																	this.grdDisp,
																																	this.grdEdit,
																																	this.label2,
																																	this.label1});
			this.Name = "frmCtrlDatebox";
			this.Text = "frmCtrlDatebox";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
