using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmCtrlCheckbox.
	/// </summary>
	public class frmCtrlTextbox : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private ppsGrid.GridRow rowDispFixed;
		private ppsGrid.GridRow rowEditFixed;
		private ppsGrid.GridRow rowDispEditFixed;
		private ppsGrid.GridCol colDispEditNo;
		private ppsGrid.GridCol colEditNo;
		private ppsGrid.GridCol colDispNo;
		private ppsGrid.Grid grdDisp;
		private ppsGrid.Grid grdEdit;
		private ppsGrid.Grid grdDispEdit;
		private ppsGrid.GridCol colDispText;
		private ppsGrid.GridCol colEditText;
		private ppsGrid.GridCol colDispEditText;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlTextbox(){
			InitializeComponent();
		}
		public void Init(){
			TextBox	txt;
			Random	rnd=new Random();

			txt=new TextBox();
			txt.Dock=DockStyle.Fill;
			grdDisp.AddRows(20);
			grdDisp.Cols["colDispText"].ControlDisplayInfo.Control=txt;
			grdDisp.Cols["colDispText"].ControlDisplayInfo.PropertyName="Text";
			foreach(GridRow r in grdDisp.Rows)
				if(r.Fixed==false)
					r["colDispText"].Value=RandomString(rnd,20);

		



			txt=new TextBox();
			txt.BorderStyle=BorderStyle.None;
			txt.Dock=DockStyle.Fill;
			grdEdit.AddRows(20);
			grdEdit.Cols["colEditText"].ControlEditInfo.Control=txt;
			grdEdit.Cols["colEditText"].ControlEditInfo.PropertyName="Text";
			foreach(GridRow r in grdEdit.Rows)
				if(r.Fixed==false)
					r["colEditText"].Value=RandomString(rnd,20);

		



		
			txt=new TextBox();
			txt.Dock=DockStyle.Fill;
			grdDispEdit.AddRows(20);
			grdDispEdit.Cols["colDispEditText"].ControlDisplayInfo.Control=txt;
			grdDispEdit.Cols["colDispEditText"].ControlDisplayInfo.PropertyName="Text";

			txt=new TextBox();
			txt.Dock=DockStyle.Fill;
			grdDispEdit.Cols["colDispEditText"].ControlEditInfo.Control=txt;
			grdDispEdit.Cols["colDispEditText"].ControlEditInfo.PropertyName="Text";
			foreach(GridRow r in grdDispEdit.Rows)
				if(r.Fixed==false)
					r["colDispEditText"].Value=RandomString(rnd,20);
		}

		
		
		public static string RandomString(Random rnd,int max){
			int			cnt=rnd.Next(max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++)
				bff[i]=(byte)rnd.Next(97,97+26);
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grdDisp = new ppsGrid.Grid();
			this.colDispNo = new ppsGrid.GridCol();
			this.colDispText = new ppsGrid.GridCol();
			this.rowDispFixed = new ppsGrid.GridRow();
			this.grdEdit = new ppsGrid.Grid();
			this.colEditNo = new ppsGrid.GridCol();
			this.colEditText = new ppsGrid.GridCol();
			this.rowEditFixed = new ppsGrid.GridRow();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.grdDispEdit = new ppsGrid.Grid();
			this.colDispEditNo = new ppsGrid.GridCol();
			this.colDispEditText = new ppsGrid.GridCol();
			this.rowDispEditFixed = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grdDisp
			// 
			this.grdDisp.Cols.AddRange(new object[] {
																								this.colDispNo,
																								this.colDispText});
			this.grdDisp.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDisp.Location = new System.Drawing.Point(16, 24);
			this.grdDisp.Name = "grdDisp";
			this.grdDisp.PreferredRowHeight = 24;
			this.grdDisp.Rows.AddRange(new object[] {
																								this.rowDispFixed});
			this.grdDisp.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDisp.Size = new System.Drawing.Size(80, 248);
			this.grdDisp.TabIndex = 0;
			// 
			// colDispNo
			// 
			this.colDispNo.AutoNumber = true;
			this.colDispNo.Fixed = true;
			this.colDispNo.Name = "colDispNo";
			this.colDispNo.Width = 25;
			this.colDispNo.WidthPercent = 35;
			// 
			// colDispText
			// 
			this.colDispText.Name = "colDispText";
			this.colDispText.WidthPercent = 100;
			this.colDispText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowDispFixed
			// 
			this.rowDispFixed.Fixed = true;
			this.rowDispFixed.Name = "rowDispFixed";
			// 
			// grdEdit
			// 
			this.grdEdit.Cols.AddRange(new object[] {
																								this.colEditNo,
																								this.colEditText});
			this.grdEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdEdit.Location = new System.Drawing.Point(104, 24);
			this.grdEdit.Name = "grdEdit";
			this.grdEdit.Rows.AddRange(new object[] {
																								this.rowEditFixed});
			this.grdEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdEdit.Size = new System.Drawing.Size(128, 248);
			this.grdEdit.TabIndex = 0;
			// 
			// colEditNo
			// 
			this.colEditNo.AutoNumber = true;
			this.colEditNo.Fixed = true;
			this.colEditNo.Name = "colEditNo";
			this.colEditNo.Width = 25;
			this.colEditNo.WidthPercent = 35;
			// 
			// colEditText
			// 
			this.colEditText.Name = "colEditText";
			this.colEditText.WidthPercent = 100;
			this.colEditText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowEditFixed
			// 
			this.rowEditFixed.Fixed = true;
			this.rowEditFixed.Name = "rowEditFixed";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "nur Anzeige";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(104, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(120, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "nur Editieren";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(232, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(160, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Anzeige+Editieren";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// grdDispEdit
			// 
			this.grdDispEdit.Cols.AddRange(new object[] {
																										this.colDispEditNo,
																										this.colDispEditText});
			this.grdDispEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDispEdit.Location = new System.Drawing.Point(240, 24);
			this.grdDispEdit.Name = "grdDispEdit";
			this.grdDispEdit.PreferredRowHeight = 24;
			this.grdDispEdit.Rows.AddRange(new object[] {
																										this.rowDispEditFixed});
			this.grdDispEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDispEdit.Size = new System.Drawing.Size(152, 248);
			this.grdDispEdit.TabIndex = 3;
			// 
			// colDispEditNo
			// 
			this.colDispEditNo.AutoNumber = true;
			this.colDispEditNo.Fixed = true;
			this.colDispEditNo.Name = "colDispEditNo";
			this.colDispEditNo.Width = 25;
			this.colDispEditNo.WidthPercent = 35;
			// 
			// colDispEditText
			// 
			this.colDispEditText.Name = "colDispEditText";
			this.colDispEditText.WidthPercent = 100;
			this.colDispEditText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowDispEditFixed
			// 
			this.rowDispEditFixed.Fixed = true;
			this.rowDispEditFixed.Name = "rowDispEditFixed";
			// 
			// frmCtrlTextbox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(398, 275);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.label3,
																																	this.grdDispEdit,
																																	this.label2,
																																	this.label1,
																																	this.grdDisp,
																																	this.grdEdit});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmCtrlTextbox";
			this.Text = "frmCtrlCheckbox";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
