using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmFonts:System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colName;
		private ppsGrid.GridCol colSize;
		private ppsGrid.GridCol colText;
		private ppsGrid.GridRow rowTitle;
		private System.ComponentModel.IContainer components = null;

		public frmFonts(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			GridRow									row;
			InstalledFontCollection fntList=new InstalledFontCollection();
			FontFamily							fntFam;
			int											fntCnt=fntList.Families.GetLength(0),fntSize,
															wdth=0;
			Graphics								gfx=this.CreateGraphics();
			Random									rnd=new Random();
			Byte[]									szList=new Byte[] {8,9,10,12,14,16,20,24,36,48,72};
			string									txt="The quick brown fox jump over the lazy dogs 0123456789";


			grid.AddRows(fntCnt*8);
			grid.Rows[0].Height=12;

			for(int y=grid.Rows.Count-1;y>0;y--){
				row=grid.Rows[y];

				try{
					fntFam=fntList.Families[rnd.Next(fntCnt)];
					fntSize=szList[rnd.Next(szList.Length)];
					row.Font	=new Font(fntFam,fntSize,FontStyle.Bold);
					//row.Height=(int)row.Font.GetHeight();

					grid.Cells["colNo",y].Value=y;
					grid.Cells["colName",y].Value=fntFam.Name;
					grid.Cells["colSize",y].Value=fntSize;
					grid.Cells["colText",y].Value=txt;

					row[0].Value="1234";

					wdth=(int)gfx.MeasureString(fntFam.Name,row.Font).Width;
					if(grid.Cols[1].Width<wdth && wdth<400)
						grid.Cols[1].Width=wdth;

					grid.Cells[3,y].Font=new Font(fntFam,10);
				}
				catch{
					grid.Cells[0,y].Value="Exception";
				}
			}
			gfx.Dispose();
			grid.Cols["colName"].Sort(eSortDirection.Ascending);
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmFonts));
			this.grid = new ppsGrid.Grid();
			this.colNo = new ppsGrid.GridCol();
			this.colName = new ppsGrid.GridCol();
			this.colSize = new ppsGrid.GridCol();
			this.colText = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Cols.AddRange(new object[] {
																						 this.colNo,
																						 this.colName,
																						 this.colSize,
																						 this.colText});
			this.grid.ControlEditInfo.Control = null;
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.grid.ForeColorFixed = System.Drawing.Color.Blue;
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.rowTitle});
			this.grid.Size = new System.Drawing.Size(244, 148);
			this.grid.TabIndex = 1;
			this.grid.FocusCellChanged += new ppsGrid.OnFocusCellChanged(this.grid_FocusCellChanged);
			this.grid.Click += new System.EventHandler(this.grid_Click);
			// 
			// colNo
			// 
			this.colNo.AutoNumber = true;
			this.colNo.Fixed = true;
			this.colNo.Name = "colNo";
			// 
			// colName
			// 
			this.colName.Name = "colName";
			// 
			// colSize
			// 
			this.colSize.Name = "colSize";
			// 
			// colText
			// 
			this.colText.Name = "colText";
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Name = "rowTitle";
			// 
			// frmFonts
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(244, 148);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid});
			this.Name = "frmFonts";
			this.Text = "Fonts";
			this.ResumeLayout(false);

		}
		#endregion

		private void grid_FocusCellChanged(object sender, ppsGrid.FocusCellChangedEventArgs e) {
		}

		private void grid_Click(object sender, System.EventArgs e) {
			Console.Write("FocusCell: "+grid.FocusCell+"  ");
			Console.Write("TopRow   : "+grid.TopRow.Row+"  ");
			Console.Write("LeftCol  : "+grid.LeftCol.Column);
			Console.WriteLine("");
		}
	}
}

