using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

using ppsGrid;

namespace grdDemo.frm{
	public class frmOutlineRow:System.Windows.Forms.Form{
		private System.Windows.Forms.Label labHitTest;
		private System.Windows.Forms.TextBox txtHitTest;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colName;
		private ppsGrid.GridCol colStadt;
		private ppsGrid.GridCol colData;
		private ppsGrid.GridCol colLevel;
		private ppsGrid.GridCol colParent;
		private ppsGrid.GridCol colFirstChild;
		private ppsGrid.GridCol colLastChild;
		private ppsGrid.GridCol colPrevRow;
		private ppsGrid.GridCol colNextRow;
		private ppsGrid.GridCol colPath;
		public ppsGrid.GridRow rowTitle;
		private ppsGrid.Grid grid;
		private System.Windows.Forms.ImageList imgList;
		private System.ComponentModel.IContainer components = null;

		public frmOutlineRow(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			GridRow	row;
			Random			rnd=new Random();
			int					y,nameIdx;
			byte[]			bff=new byte[16];
			Font				fnt=grid.Font;
			DateTime		dte=new DateTime(DateTime.Today.Year,1,1);

			try{
//			grid.BeginUpdate();

				grid.Scrollbar=eScrollbar.Both;
				grid.Cols[0].Width=50;
				grid.Cols[1].Width=grid.Cols[2].Width=grid.Cols[3].Width=grid.Cols[4].Width=150;
				grid.Cols[10].Width=400;
				grid.Cols[0].FormatString="0000";
				grid.Cols[0].Fixed=true;

				grid.Cells["colName",0].Value="Name";
				grid.Cells["colStadt",0].Value="Stadt";
				grid.Cells["colData",0].Value="Daten";
				grid.Cells["colLevel",0].Value="Level";
				grid.Cells["colParent",0].Value="Parent";
				grid.Cells["colFirstChild",0].Value="First-Child";
				grid.Cells["colLastChild",0].Value="Last-Child";
				grid.Cells["colPrevRow",0].Value="Prev-Row";
				grid.Cells["colNextRow",0].Value="Next-Row";
				grid.Cells["colPath",0].Value="Path";

				grid.Cells["colPath",0].Image=(Bitmap)imgList.Images[0];
				grid.Cells["colPath",0].ImageAlignHorz=eContentAlign.Far;


				grid.AddRows(10);
				grid.Rows[1].Fixed=grid.Rows[2].Fixed=true;
				grid.Rows[3].BackColorCell=Color.FromKnownColor(KnownColor.Gold);

				for(int i=0;i<8;i++){
					y=255-(i*8);
					grid.LevelColors.Add(new GridColor(Color.FromArgb(y,y,y)));
					grid.LevelColors[i].ForeColorCell=Color.FromArgb(i*16,i*16,i*16);
				}


				grid.ResetCellPadding();
				grid.BackColorApp=Color.Yellow;
				y=grid.FixedRowCount;
				while(y<grid.Rows.Count){
					row=grid.Rows[y];
					if(rnd.Next(10)>2+row.Outline.Level)
						row.Outline.AddChilds(rnd.Next(8-row.Outline.Level)+1);

					for(int x=1;x<3;x++)
						grid.Cells[x,y].Value=RandomString(rnd,2,rnd.Next(12)+2);


					switch(rnd.Next(5)){
						case 0:
							grid.Cells[3,y].Value=rnd.Next();
							break;
						case 1:
							grid.Cells[3,y].Value=rnd.NextDouble()*1000;
							break;
						case 2:
							grid.Cells[3,y].Value=dte.AddDays(rnd.Next(366));
							break;
						case 3:
						case 4:
							grid.Cells[3,y].Value=RandomString(rnd,2,rnd.Next(10)+2);
							break;
					}

					if(rnd.Next(3)==1)
						grid.Cells[rnd.Next(grid.Cols.Count),y].CellBorderSide=(eCellBorderSide)rnd.Next(16);
					y++;
				}

				
				for(y=grid.FixedRowCount;y<grid.Rows.Count;y++){
					row=grid.Rows[y];
					grid.Cells["colLevel",y].Value=row.Outline.Level;
					nameIdx=grid.Cols["colName"].Column;

					if(row.Outline.Parent!=null)
						grid.Cells["colParent",y].Value=grid.Cells[nameIdx,row.Outline.Parent.Row].Value;
					if(row.Outline.FirstChild!=null)
						grid.Cells["colFirstChild",y].Value=grid.Cells[nameIdx,row.Outline.FirstChild.Row].Value;
					if(row.Outline.LastChild!=null)
						grid.Cells["colLastChild",y].Value=grid.Cells[nameIdx,row.Outline.LastChild.Row].Value;
					if(row.Outline.PrevRow!=null)
						grid.Cells["colPrevRow",y].Value=grid.Cells[nameIdx,row.Outline.PrevRow.Row].Value;
					if(row.Outline.NextRow!=null)
						grid.Cells["colNextRow",y].Value=grid.Cells[nameIdx,row.Outline.NextRow.Row].Value;
					grid.Cells["colPath",y].Value=row.Outline.FullPath(2,".");
				}
			}

			catch(Exception  ex){
				MessageBox.Show(ex.StackTrace);
			}
			finally{
//			grid.EndUpdate();
			}
		}

		private string RandomString(Random rnd,int min,int max){
			int			cnt=rnd.Next(min,max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++)
				bff[i]=(byte)rnd.Next(97,97+26);
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmOutlineRow));
			this.colNo = new ppsGrid.GridCol();
			this.colName = new ppsGrid.GridCol();
			this.colStadt = new ppsGrid.GridCol();
			this.colData = new ppsGrid.GridCol();
			this.colLevel = new ppsGrid.GridCol();
			this.colParent = new ppsGrid.GridCol();
			this.colFirstChild = new ppsGrid.GridCol();
			this.colLastChild = new ppsGrid.GridCol();
			this.colPrevRow = new ppsGrid.GridCol();
			this.colNextRow = new ppsGrid.GridCol();
			this.colPath = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.labHitTest = new System.Windows.Forms.Label();
			this.txtHitTest = new System.Windows.Forms.TextBox();
			this.grid = new ppsGrid.Grid();
			this.imgList = new System.Windows.Forms.ImageList(this.components);
			this.SuspendLayout();
			// 
			// colNo
			// 
			this.colNo.AutoNumber = true;
			this.colNo.Name = "colNo";
			// 
			// colName
			// 
			this.colName.Name = "colName";
			this.colName.OutlineMode = true;
			// 
			// colStadt
			// 
			this.colStadt.Name = "colStadt";
			this.colStadt.StringAlignHorz = ppsGrid.eContentAlign.Center;
			// 
			// colData
			// 
			this.colData.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.colData.Name = "colData";
			this.colData.StringAlignHorz = ppsGrid.eContentAlign.Far;
			// 
			// colLevel
			// 
			this.colLevel.Name = "colLevel";
			// 
			// colParent
			// 
			this.colParent.Name = "colParent";
			// 
			// colFirstChild
			// 
			this.colFirstChild.Name = "colFirstChild";
			// 
			// colLastChild
			// 
			this.colLastChild.Name = "colLastChild";
			// 
			// colPrevRow
			// 
			this.colPrevRow.Name = "colPrevRow";
			// 
			// colNextRow
			// 
			this.colNextRow.Name = "colNextRow";
			// 
			// colPath
			// 
			this.colPath.Name = "colPath";
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.rowTitle.Name = "rowTitle";
			// 
			// labHitTest
			// 
			this.labHitTest.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.labHitTest.Location = new System.Drawing.Point(8, 552);
			this.labHitTest.Name = "labHitTest";
			this.labHitTest.Size = new System.Drawing.Size(80, 16);
			this.labHitTest.TabIndex = 4;
			this.labHitTest.Text = "GridHitTestInfo";
			// 
			// txtHitTest
			// 
			this.txtHitTest.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtHitTest.Location = new System.Drawing.Point(92, 548);
			this.txtHitTest.Name = "txtHitTest";
			this.txtHitTest.Size = new System.Drawing.Size(648, 21);
			this.txtHitTest.TabIndex = 5;
			this.txtHitTest.Text = "";
			// 
			// grid
			// 
			this.grid.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.grid.BackColorFixedGradient = System.Drawing.Color.RosyBrown;
			this.grid.BackColorHighlight = System.Drawing.Color.LightSteelBlue;
			this.grid.BackColorRowAlternate = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.grid.CellFrameType = ppsGrid.eCellFrameType.None;
			this.grid.CellHomeVisible = true;
			this.grid.Cols.AddRange(new object[] {
																						 this.colNo,
																						 this.colName,
																						 this.colStadt,
																						 this.colData,
																						 this.colLevel,
																						 this.colParent,
																						 this.colFirstChild,
																						 this.colLastChild,
																						 this.colPrevRow,
																						 this.colNextRow,
																						 this.colPath});
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.Location = new System.Drawing.Point(4, 4);
			this.grid.Name = "grid";
			this.grid.OutlineSmooth = true;
			this.grid.Rows.AddRange(new object[] {
																						 this.rowTitle});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.ScrollbarVisible = ppsGrid.eScrollbarVisible.Required;
			this.grid.SelectionDashStyle = ppsGrid.eDashStyle.Solid;
			this.grid.SelectionFrameWidth = 4;
			this.grid.SelectionMode = ppsGrid.eSelectionMode.MultipleEx;
			this.grid.SelectionType = ppsGrid.eSelectionType.Free;
			this.grid.Size = new System.Drawing.Size(736, 541);
			this.grid.TabIndex = 7;
			this.grid.AfterColumnMove += new ppsGrid.OnAfterColumnMove(this.grid_AfterColumnMove);
			this.grid.AfterSelectionChange += new ppsGrid.OnAfterSelectionChange(this.grid_AfterSelectionChange);
			this.grid.BeforeColumnSort += new ppsGrid.OnBeforeColumnSort(this.grid_BeforeColumnSort);
			this.grid.SelectionEnd += new ppsGrid.OnSelectionEnd(this.grid_SelectionEnd);
			this.grid.FocusCellChanged += new ppsGrid.OnFocusCellChanged(this.grid_FocusCellChanged);
			this.grid.AfterExpand += new ppsGrid.OnAfterExpand(this.grid_AfterExpand);
			this.grid.BeforeExpand += new ppsGrid.OnBeforeExpand(this.grid_BeforeExpand);
			this.grid.BeforeCollapse += new ppsGrid.OnBeforeCollapse(this.grid_BeforeCollapse);
			this.grid.BeforeColumnMove += new ppsGrid.OnBeforeColumnMove(this.grid_BeforeColumnMove);
			this.grid.AfterColumnSize += new ppsGrid.OnAfterColumnSize(this.grid_AfterColumnSize);
			this.grid.MouseDown += new System.Windows.Forms.MouseEventHandler(this.grid_MouseDown);
			this.grid.BeforeSelectionChange += new ppsGrid.OnBeforeSelectionChange(this.grid_BeforeSelectionChange);
			this.grid.AfterColumnSort += new ppsGrid.OnAfterColumnSort(this.grid_AfterColumnSort);
			this.grid.AfterRowSize += new ppsGrid.OnAfterRowSize(this.grid_AfterRowSize);
			this.grid.AfterRowMove += new ppsGrid.OnAfterRowMove(this.grid_AfterRowMove);
			this.grid.BeforeColumnSize += new ppsGrid.OnBeforeColumnSize(this.grid_BeforeColumnSize);
			this.grid.SelectionStart += new ppsGrid.OnSelectionStart(this.grid_SelectionStart);
			this.grid.AfterCollapse += new ppsGrid.OnAfterCollapse(this.grid_AfterCollapse);
			this.grid.Click += new System.EventHandler(this.grid_Click);
			this.grid.BeforeRowMove += new ppsGrid.OnBeforeRowMove(this.grid_BeforeRowMove);
			this.grid.BeforeRowSize += new ppsGrid.OnBeforeRowSize(this.grid_BeforeRowSize);
			// 
			// imgList
			// 
			this.imgList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgList.ImageSize = new System.Drawing.Size(16, 16);
			this.imgList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgList.ImageStream")));
			this.imgList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// frmOutlineRow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(744, 549);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid,
																																	this.txtHitTest,
																																	this.labHitTest});
			this.DockPadding.All = 4;
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "frmOutlineRow";
			this.Text = "Outline";
			this.ResumeLayout(false);

		}
		#endregion

		private void grid_AfterColumnMove(object sender, ppsGrid.AfterColumnMoveEventArgs e) {
			Debug.WriteLine("afterColMove:"+e.ColBefore.ToString()+" nach "+e.ColAfter.ToString());
		}

		private void grid_AfterColumnSort(object sender, ppsGrid.AfterColumnSortEventArgs e) {
			Debug.WriteLine("AfterColSort:"+e.Column.ToString()+" "+e.Direction.ToString());
		}

		private void grid_AfterColumnSize(object sender, ppsGrid.AfterColumnSizeEventArgs e) {
			Debug.WriteLine("afterColSize:"+e.Column.ToString()+" von "+e.OldWidth.ToString()+" nach "+grid.Cols[e.Column].Width.ToString());
		}

		private void grid_AfterRowMove(object sender, ppsGrid.AfterRowMoveEventArgs e) {
			Debug.WriteLine("afterRowMove:"+e.RowBefore.ToString()+" nach "+e.RowAfter.ToString());
		}

		private void grid_AfterRowSize(object sender, ppsGrid.AfterRowSizeEventArgs e) {
			Debug.WriteLine("afterRowSize:"+e.Row.ToString()+" von "+e.OldHeight.ToString()+" nach "+grid.Rows[e.Row].Height.ToString());
		}

		private void grid_BeforeColumnMove(object sender, ppsGrid.BeforeColumnMoveEventArgs e) {
			Debug.WriteLine("beforeColMove:"+e.Column.ToString());
		}

		private void grid_BeforeColumnSize(object sender, ppsGrid.BeforeColumnSizeEventArgs e) {
			Debug.WriteLine("beforeColSize:"+e.Column.ToString());
		}

		private void grid_BeforeColumnSort(object sender, ppsGrid.BeforeColumnSortEventArgs e) {
			Debug.WriteLine("beforeColSort:"+e.Column.ToString()+" "+e.Direction.ToString());
		}

		private void grid_BeforeRowMove(object sender, ppsGrid.BeforeRowMoveEventArgs e) {
			Debug.WriteLine("beforeRowMove:"+e.Row.ToString());
		}

		private void grid_BeforeRowSize(object sender, ppsGrid.BeforeRowSizeEventArgs e) {
			Debug.WriteLine("beforeRowSize:"+e.Row.ToString());
		}


		private void grid_Click(object sender, System.EventArgs e) {
			GridHitTestInfo	hi=grid.HitTest(grid.PointToClient(MousePosition));
			Debug.WriteLine("HitTest:"+hi.Type.ToString());
		}

		private void grid_BeforeExpand(object sender, ppsGrid.BeforeExpandEventArgs e) {
			string s=(grid.Rows[e.Row].Outline.IsOpen)?"":" nicht";
			Debug.WriteLine("beforeExpand:"+e.Column+"."+e.Row+" ist"+s+" offen");
		}

		private void grid_AfterExpand(object sender, ppsGrid.AfterExpandEventArgs e) {
			string s=(grid.Rows[e.Row].Outline.IsOpen)?"":" nicht";
			Debug.WriteLine("afterExpand:"+e.Column+"."+e.Row+" ist"+s+" offen");
		}

		private void grid_BeforeCollapse(object sender, ppsGrid.BeforeCollapseEventArgs e) {
			string s=(grid.Rows[e.Row].Outline.IsOpen)?"":" nicht";
			Debug.WriteLine("beforeCollapsed:"+e.Column+"."+e.Row+" ist"+s+" offen");
		}

		private void grid_AfterCollapse(object sender, ppsGrid.AfterCollapseEventArgs e) {
			string s=(grid.Rows[e.Row].Outline.IsOpen)?"":" nicht";
			Debug.WriteLine("afterCollapsed:"+e.Column+"."+e.Row+" ist"+s+" offen");
		}

		private void grid_FocusCellChanged(object sender, ppsGrid.FocusCellChangedEventArgs e) {
//			Debug.WriteLine("focusCellChanged:"+e.Column.ToString()+"."+e.Row.ToString());
		}


		private void grid_SelectionEnd(object sender, ppsGrid.SelectionEndEventArgs e) {
			Debug.WriteLine("SelectionEnd:"+e.Column.ToString()+"."+e.Row.ToString());
		}
		private void grid_SelectionStart(object sender, ppsGrid.SelectionStartEventArgs e) {
			Debug.WriteLine("SelectionStart:"+e.Column.ToString()+"."+e.Row.ToString());
		}

		private void grid_BeforeSelectionChange(object sender, ppsGrid.BeforeSelectionChangeEventArgs e) {
			Debug.WriteLine("beforeSelChanged:"+e.Column.ToString()+"."+e.Row.ToString());
		}
		private void grid_AfterSelectionChange(object sender, ppsGrid.AfterSelectionChangeEventArgs e) {
			Debug.WriteLine("afterSelChanged:"+e.Column.ToString()+"."+e.Row.ToString());
		}

		private void grid_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
 			GridHitTestInfo	hi=grid.HitTest(new Point(e.X,e.Y));
			txtHitTest.Text=hi.Type.ToString()+":  "+hi.Column.ToString()+" "+hi.Row.ToString();
		}
	}
}

