using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

using ppsGrid;

namespace grdDemo.frm{
	public class frmStrTrim:System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridRow gridRow1;
		private ppsGrid.GridCol colChar;
		private ppsGrid.GridCol colWord;
		private ppsGrid.GridCol colElChar;
		private ppsGrid.GridCol colElWord;
		private ppsGrid.GridCol colPath;
		private System.ComponentModel.IContainer components = null;

		public frmStrTrim(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			Random			rnd=new Random();

			grid.Scrollbar=eScrollbar.Both;
			grid.AddRows(100);

			foreach(GridCol c in grid.Cols){
				c.StringTrimming=(StringTrimming)Enum.GetValues(typeof(StringTrimming)).GetValue(c.Column+1);
				c[0].Value=c.StringTrimming.ToString();
			}
//			grid[0,0].Value="Char";
//			grid[1,0].Value="Word";
//			grid[2,0].Value="EllipseChar";
//			grid[3,0].Value="EllipseWord";
//			grid[4,0].Value="Path";

			grid.Cells[2,2].BackColorCell=Color.Silver;

			grid.Rows[1].BackColorCell=Color.Blue;
			grid.Rows[2].BackColorCell=Color.Blue;
			grid.Rows[3].BackColorCell=Color.Blue;

			grid.Cols[1].BackColorCell=Color.Yellow;
			grid.Cols[2].BackColorCell=Color.Yellow;
			grid.Cols[3].BackColorCell=Color.Yellow;

			grid.BackColorCell=Color.Lime;
			


			for(int y=grid.FixedRowCount;y<grid.Rows.Count;y++)
				for(int x=grid.FixedColCount;x<grid.Cols.Count;x++)
					grid.Cells[x,y].Value=RandomString(rnd,32);
		}
		private string RandomString(Random rnd,int max){
			int			cnt=rnd.Next(max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++){
				bff[i]=(byte)rnd.Next(97,97+26);
				if(rnd.Next(8)==0 && i>0 && i<cnt-1)	bff[i]=32;
			}
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid = new ppsGrid.Grid();
			this.colChar = new ppsGrid.GridCol();
			this.colWord = new ppsGrid.GridCol();
			this.colElChar = new ppsGrid.GridCol();
			this.colElWord = new ppsGrid.GridCol();
			this.colPath = new ppsGrid.GridCol();
			this.gridRow1 = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Cols.AddRange(new object[] {
																						 this.colChar,
																						 this.colWord,
																						 this.colElChar,
																						 this.colElWord,
																						 this.colPath});
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.gridRow1});
			this.grid.SelectionMode = ppsGrid.eSelectionMode.Multiple;
			this.grid.SelectionType = ppsGrid.eSelectionType.Free;
			this.grid.Size = new System.Drawing.Size(436, 129);
			this.grid.StringAlignHorz = ppsGrid.eContentAlign.Center;
			this.grid.StringAlignVert = ppsGrid.eContentAlign.Center;
			this.grid.TabIndex = 1;
			// 
			// colChar
			// 
			this.colChar.Name = "colChar";
			this.colChar.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.colChar.StringTrimming = System.Drawing.StringTrimming.Character;
			// 
			// colWord
			// 
			this.colWord.Name = "colWord";
			this.colWord.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.colWord.StringTrimming = System.Drawing.StringTrimming.Word;
			// 
			// colElChar
			// 
			this.colElChar.Name = "colElChar";
			this.colElChar.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.colElChar.StringTrimming = System.Drawing.StringTrimming.EllipsisCharacter;
			// 
			// colElWord
			// 
			this.colElWord.Name = "colElWord";
			this.colElWord.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.colElWord.StringTrimming = System.Drawing.StringTrimming.EllipsisWord;
			// 
			// colPath
			// 
			this.colPath.Name = "colPath";
			this.colPath.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.colPath.StringTrimming = System.Drawing.StringTrimming.EllipsisPath;
			// 
			// gridRow1
			// 
			this.gridRow1.Fixed = true;
			this.gridRow1.Name = "gridRow1";
			// 
			// frmStrTrim
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(436, 129);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid});
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "frmStrTrim";
			this.Text = "Stringtrimming...";
			this.ResumeLayout(false);

		}
		#endregion

	}
}

