using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmTextAlign:System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colLeft;
		private ppsGrid.GridCol colCenter;
		private ppsGrid.GridCol colRight;
		private ppsGrid.GridRow rowTitle;
		private ppsGrid.GridRow rowTop;
		private ppsGrid.GridRow rowCenter;
		private ppsGrid.GridRow rowBottom;
		private System.ComponentModel.IContainer components = null;

		public frmTextAlign(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			string	txt="The quick brown fox jump over the lazy dogs 0123456789";
			
			for(int c=grid.FixedColCount;c<grid.Cols.Count;c++)
				for(int r=grid.FixedRowCount;r<grid.Rows.Count;r++)
					grid.Cells[c,r].Value=txt;

			grid.Cells["colLeft","rowTop"].StringAlignHorz=
				grid.Cells["colLeft","rowCenter"].StringAlignHorz=
				grid.Cells["colLeft","rowBottom"].StringAlignHorz=ppsGrid.eContentAlign.Near;
			grid.Cells["colCenter","rowTop"].StringAlignHorz=
				grid.Cells["colCenter","rowCenter"].StringAlignHorz=
				grid.Cells["colCenter","rowBottom"].StringAlignHorz=ppsGrid.eContentAlign.Center;
			grid.Cells["colRight","rowTop"].StringAlignHorz=
				grid.Cells["colRight","rowCenter"].StringAlignHorz=
				grid.Cells["colRight","rowBottom"].StringAlignHorz=ppsGrid.eContentAlign.Far;

			grid.Cells["colLeft","rowTop"].StringAlignVert=
				grid.Cells["colCenter","rowTop"].StringAlignVert=
				grid.Cells["colRight","rowTop"].StringAlignVert=ppsGrid.eContentAlign.Near;
			grid.Cells["colLeft","rowCenter"].StringAlignVert=
				grid.Cells["colCenter","rowCenter"].StringAlignVert=
				grid.Cells["colRight","rowCenter"].StringAlignVert=ppsGrid.eContentAlign.Center;
			grid.Cells["colLeft","rowBottom"].StringAlignVert=
				grid.Cells["colCenter","rowBottom"].StringAlignVert=
				grid.Cells["colRight","rowBottom"].StringAlignVert=ppsGrid.eContentAlign.Far;
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid = new ppsGrid.Grid();
			this.colNo = new ppsGrid.GridCol();
			this.colLeft = new ppsGrid.GridCol();
			this.colCenter = new ppsGrid.GridCol();
			this.colRight = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.rowTop = new ppsGrid.GridRow();
			this.rowCenter = new ppsGrid.GridRow();
			this.rowBottom = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.BackColorColAlternate = System.Drawing.Color.Empty;
			this.grid.BackColorRowAlternate = System.Drawing.Color.Empty;
			this.grid.Cols.AddRange(new object[] {
																						 this.colNo,
																						 this.colLeft,
																						 this.colCenter,
																						 this.colRight});
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.rowTitle,
																						 this.rowTop,
																						 this.rowCenter,
																						 this.rowBottom});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.Size = new System.Drawing.Size(496, 209);
			this.grid.TabIndex = 0;
			// 
			// colNo
			// 
			this.colNo.BackColorFixed = System.Drawing.Color.Gray;
			this.colNo.Fixed = true;
			this.colNo.ForeColorFixed = System.Drawing.Color.White;
			this.colNo.Name = "colNo";
			this.colNo.StringAlignHorz = ppsGrid.eContentAlign.Center;
			// 
			// colLeft
			// 
			this.colLeft.BackColorFixed = System.Drawing.Color.Gray;
			this.colLeft.ForeColorFixed = System.Drawing.Color.White;
			this.colLeft.Name = "colLeft";
			this.colLeft.StringAlignHorz = ppsGrid.eContentAlign.Near;
			this.colLeft.Width = 120;
			// 
			// colCenter
			// 
			this.colCenter.BackColorFixed = System.Drawing.Color.Gray;
			this.colCenter.ForeColorFixed = System.Drawing.Color.White;
			this.colCenter.Name = "colCenter";
			this.colCenter.StringAlignHorz = ppsGrid.eContentAlign.Center;
			this.colCenter.Width = 120;
			// 
			// colRight
			// 
			this.colRight.BackColorFixed = System.Drawing.Color.Gray;
			this.colRight.ForeColorFixed = System.Drawing.Color.White;
			this.colRight.Name = "colRight";
			this.colRight.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colRight.Width = 120;
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Height = 32;
			this.rowTitle.Name = "rowTitle";
			this.rowTitle.StringAlignVert = ppsGrid.eContentAlign.Center;
			// 
			// rowTop
			// 
			this.rowTop.BackColorFixed = System.Drawing.Color.Gray;
			this.rowTop.Height = 48;
			this.rowTop.Name = "rowTop";
			this.rowTop.StringAlignVert = ppsGrid.eContentAlign.Near;
			// 
			// rowCenter
			// 
			this.rowCenter.BackColorFixed = System.Drawing.Color.Gray;
			this.rowCenter.Height = 48;
			this.rowCenter.Name = "rowCenter";
			this.rowCenter.StringAlignVert = ppsGrid.eContentAlign.Center;
			// 
			// rowBottom
			// 
			this.rowBottom.BackColorFixed = System.Drawing.Color.Gray;
			this.rowBottom.Height = 48;
			this.rowBottom.Name = "rowBottom";
			this.rowBottom.StringAlignVert = ppsGrid.eContentAlign.Far;
			// 
			// frmTextAlign
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(496, 209);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid});
			this.Name = "frmTextAlign";
			this.Text = "Text-Alignment";
			this.ResumeLayout(false);

		}
		#endregion

	}
}

